// #autoload
// #name = DerkyleMsgTaunt
// #version = 4.0
// #date = July 6, 2001
// #author = Derkyle &Venom850, Matt Timlin, Special Thanks to PJ
// #warrior = Derkyle
// #email = venom850@manaflux.com
// #web = http://www.manaflux.com
// #description = Updated for SuperStats 6.52, Will display Taunts showing death and or kill count, Suicides too :) REQUIRES PJ's SUPERSTATS! and PJ Support Package!
// #status = Hopefully done LOL...
// #readme = scripts/autoexec/DerkyleMsgTaunt.txt
// #config = DerkMsgTConfig

package DerkMsgTaunt {


function DerkToggle(%val) {
	if (%val) { //at keypress

			if ($DerkTauntIsToggled){ //is it already on?
			$DerkTauntIsToggled = false;//if yes turn it off
			addMessageHudLine("DerkTauntMsg is now OFF!");
                        }
		else{
			$DerkTauntIsToggled = true;//if no turn it on
                        addMessageHudLine("DerkTauntMsg is now ON!");
	            }
	}
 }


function DerkHandleJoin(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid) {

		$DerkCurrentClientId = %clientId;
		$DerkCurrentPlayerName = detag(%clientName);


//end Function DerkHandleJoin
}

function DerkHandleKill(%msgType, %msgString, %victimName, %vgen, %vposs, %killerName, %kgen, %kposs, %damageType)
{
	%killer = detag(%killerName);
	%victim = detag(%victimName);
	$DerkMsgType = detag(%msgType);

	%Derkclientv = getClientId(%victim);
	%Derkplayerv = $PlayerList[%Derkclientv];
	$DerkMessage = "";
	$DerkTemp    = "";


//toggle part
if($DerkTauntIsToggled){

	//DOH You killed yourself stupid!
	if($DerkMsgType $= "msgSuicide" || $DerkMsgType $= "msgSelfKill" || $DerkMsgType $= "msgTurretSelfKill") {
	
		if(isManagerName(%victim)) {

		$SuicideDerkCount = PJStatsData.Suicides;
		$SuicideDerkCount = $SuicideDerkCount + 1;

		//lets get the message from saved settings and add them
		$DerkMessage = strReplace($pref::DerkMsgTaunt::Message, "$count$", "\c1[#" @ $SuicideDerkCount @ "]\c4");
		

		//commandToServer('MessageSent',"Whoops! Suicide \c1[#" @ $SuicideDerkCount @ "]");
		commandToServer('MessageSent',$DerkMessage);

		return;
		}

		return;
	}

	//lava death	
	if($DerkMsgType $= "msgLavaKill") {

		if(isManagerName(%victim)) {
	//add to lava count + 1
	$LavaCountAdd = PJStatsData.VictimmsgLavaKill[%gametype];
	$LavaCountAdd = $LavaCountAdd + 1;


	//lets get the message from saved settings and add them
	$DerkMessage = strReplace($pref::DerkMsgTaunt::Message2, "$count$", "\c1[#" @ $LavaCountAdd @ "]\c4");
			
	//commandToServer('MessageSent',"Blasted Lava Gods! Lava Death \c1[#" @ $LavaCountAdd @ "]");
	commandToServer('MessageSent',$DerkMessage);
		return;
		}

	return;
	}

	
	//lava death	
	if($DerkMsgType $= "msgTeamKill") {
	//do nothing	
	return;
	}


	//lets make sure there is a victum and or a killer otherwise return nothing
	if(%killer $= "" || %victim $= "")
	return;

	
	//check for nulls and or error with damage types
	if(strstr(strlwr(%killer), "<null>") != -1 || strstr(strlwr(%victim), "<null>") != -1 || %damageType == 0)
         return;

			

	//You killed someone Whoopie for you!
	if(isManagerName(%killer)) {

	//check for a bot

		if(%Derkplayerv.isBot) {
			//ignore
		return;
		}


	//add to count +1
	$WeaponKillDerkCount = PJStatsData.WKUYOU[%damageType];
	$WeaponKillDerkCount = $WeaponKillDerkCount + 1;
	$DerkWeaponUsed = TryNameAgain(%damageType);


	//double check that the weapon name shows
	if($DerkWeaponUsed $= "") {
	//try to load it again

	$DerkWeaponUsed = TryNameAgain(%damageType);
	
	}

	//since this is a multiple grab to prevent spam errors because it does happen we will call the message from
	//a function for this one
	$DerkMessage = GetKillMsgNow(%victim,$DerkWeaponUsed,$WeaponKillDerkCount);
  
	//try again if empty

	if($DerkMessage $= "") {
	//try to load it again

	$DerkMessage = GetKillMsgNow(%victim,$DerkWeaponUsed,$WeaponKillDerkCount);
	
	}



	//commandToServer('MessageSent',"Wohoo! \c2" @ %victim @ "\c4 is " @ $DerkWeaponUsed @ " victim \c1[#" @ $WeaponKillDerkCount @ "]");

	commandToServer('MessageSent',$DerkMessage);

	return;
	}

	
	//end toggle if
	}
	
	else {
	//do nothing
	return;
	}


//end Function DerkHandleKill
}


function GetKillMsgNow(%vicD, %weaponD, %countD) {

//one
$DerkTemp = strReplace($pref::DerkMsgTaunt::Message3, "$name$", "\c2" @ %vicD @ "\c4");

//two
$DerkTemp = strReplace($DerkTemp, "$weapon$", "" @ %weaponD @ "");

//three

$DerkTemp = strReplace($DerkTemp, "$count$", "\c1[#" @ %countD @ "]\c4");


return $DerkTemp;

}
 

//setup the Call Backs!
function DerkMsgTauntLoad()
{

	//handle Join
	addMessageCallback('MsgClientJoin', DerkHandleJoin);

	//suicides
	addMessageCallBack('msgSuicide', DerkHandleKill);
	addMessageCallBack('msgSelfKill', DerkHandleKill);
	addMessageCallBack('msgTurretSelfKill', DerkHandleKill);


	//kill msg's
	addMessageCallBack('MsgLegitKill', DerkHandleKill);
	addMessageCallBack('MsgHeadshotKill', DerkHandleKill);
	addMessageCallBack('msgVehicleKill', DerkHandleKill);
	addMessageCallBack('msgCTurretKill', DerkHandleKill);
	addMessageCallBack('msgExplosionKill', DerkHandleKill);
	addMessageCallBack('msgVehicleSpawnKill', DerkHandleKill);
	addMessageCallBack('msgVehicleCrash', DerkHandleKill);
	addMessageCallBack('msgTurretKill', DerkHandleKill);
	addMessageCallBack('msgOOBKill', DerkHandleKill);
	addMessageCallBack('msgCampKill', DerkHandleKill);
	addMessageCallBack('msgTeamKill', DerkHandleKill);
	addMessageCallBack('msgLavaKill', DerkHandleKill);
	addMessageCallBack('msgLightningKill', DerkHandleKill);
	addMessageCallBack('MsgRogueMineKill', DerkHandleKill);


//end Function DerkMsgTauntLoad
}


//-------------------------------START MAIN LAUNCH STUFF --------------------------

//start Launch Mode
function DispatchLaunchMode()
{
	DerkMsgTauntLoad();

	parent::DispatchLaunchMode();

//end Function DispatchLaunchMode
}

//check Wake
function LoadingGui::onWake(%this)
{
	if (!$DerkMsgTauntLoad)
	{
		$DerkMsgTauntLoad = true;
	}
	
	parent::onWake(%this);

//end Function LoadingGui
}

	function OptionsDlg::onWake( %this ) {//Classic key binding
		if($DerkTauntToggleBind $= "false") {
			$RemapName[$RemapCount]="DerkTauntMSG Toggle";
			$RemapCmd[$RemapCount]="DerkToggle";
			$RemapCount++;
			$DerkTauntToggleBind = "true";
		}
		parent::onWake( %this );
	}


//function to try to load the name again
function TryNameAgain(%detag){

//first check the old ver

	if($DamageTypeText[%detag] $= "")
	{
	//use the new one
	%detag = PJModData.damagetype[%detag];
	}
	else
	{
	//old one works
	%detag = $DamageTypeText[%detag];
	}

return %detag;

}


//-------------------------------END MAIN LAUNCH STUFF --------------------------



function DerkMsgTauntSetup (%this){

	//check for empty messages DUH
	if($pref::DerkMsgTaunt::Message $= ""){
		$pref::DerkMsgTaunt::Message = "Whoops! Suicide $count$.";
	}

	if($pref::DerkMsgTaunt::Message2 $= ""){
		$pref::DerkMsgTaunt::Message2 = "Blasted Lava Gods! Lava Death $count$.";
	}

	if($pref::DerkMsgTaunt::Message3 $= ""){
		$pref::DerkMsgTaunt::Message3 = "Wohoo! $name$ is $weapon$ victim $count$.";
	}

	//make the GUI
    	new GuiControl(DerkMsgTConfig) {
    		profile = "GuiDefaultProfile";
    		horizSizing = "center";
    		vertSizing = "center";
    		position = "0 0";
    		extent = "640 610";
    		minExtent = "8 8";
    		visible = "1";
    		hideCursor = "0";
    		bypassHideCursor = "0";
    		helpTag = "0";

    		new ShellPaneCtrl() {
    			profile = "ShellPaneProfile";
    			horizSizing = "center";
    			vertSizing = "center";
    			position = "0 0";
    			extent = "251 330";
    			minExtent = "48 92";
    			visible = "1";
    			hideCursor = "0";
    			bypassHideCursor = "0";
    			helpTag = "0";
    			text = "DerkMsgTaunt";
    			longTextBuffer = "0";
    			maxLength = "255";
    			noTitleBar = "0";

    			new ShellFieldCtrl() {
    				profile = "ShellFieldProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "20 29";
    				extent = "211 284";
    				minExtent = "16 18";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    			};
    			new GuiTextCtrl(DerkMsgTMessageConfigText) {
    				profile = "ShellTextProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "30 30";
    				extent = "109 22";
    				minExtent = "8 8";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				text = "Taunt Messages (Suicide/Lava/Kill):";
    			};


    			new GuiTextCtrl(DerkMsgTMessage1) {
    				profile = "ShellTextProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "30 50";
    				extent = "109 22";
    				minExtent = "8 8";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				text = "Suicide:";
    			};

    			new ShellTextEditCtrl(DerkMsgTMessageBox) {
    				profile = "NewTextEditProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "20 60";
    				extent = "209 38";
    				minExtent = "32 38";
    				visible = "1";
    				hideCursor = "0";
                                bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				variable = "$pref::DerkMsgTaunt::Message";
    			};


    			new GuiTextCtrl(DerkMsgTMessage2) {
    				profile = "ShellTextProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "30 95";
    				extent = "109 22";
    				minExtent = "8 8";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				text = "Lava:";
    			};

    			new ShellTextEditCtrl(DerkMsgTMessageBox2) {
    				profile = "NewTextEditProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "20 105";
    				extent = "209 38";
    				minExtent = "32 38";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				variable = "$pref::DerkMsgTaunt::Message2";
    			};



    			new GuiTextCtrl(DerkMsgTMessage3) {
    				profile = "ShellTextProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "30 140";
    				extent = "109 22";
    				minExtent = "8 8";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				text = "Kill:";
    			};


    			new ShellTextEditCtrl(DerkMsgTMessageBox3) {
    				profile = "NewTextEditProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "20 150";
    				extent = "209 38";
    				minExtent = "32 38";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				variable = "$pref::DerkMsgTaunt::Message3";
    			};
			

			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "59 195";
				extent = "140 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "DerkUpdateMessages();";
				helpTag = "0";
				text = "Apply Settings";
				simpleStyle = "0";
			};

    			new GuiTextCtrl(DerkMsgTMessageRem) {
    				profile = "ShellTextProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "30 235";
    				extent = "109 22";
    				minExtent = "8 8";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				text = "Don't forget the special varibales!";

    			};


    			new GuiTextCtrl(DerkMsgTMessageRem2) {
    				profile = "ShellTextProfile";
    				horizSizing = "right";
    				vertSizing = "bottom";
    				position = "30 260";
    				extent = "109 22";
    				minExtent = "8 8";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				longTextBuffer = "0";
    				maxLength = "255";
    				text = "$name$ , $weapon$ , and $count$! ";

    			};


		new GuiMLTextCtrl(DerkyleMsgTHelp) {
			profile = "ShellAltTextProfile";
			position = "110 290";
			extent = "30 15";
			visible = "1";
		};


            };
        };

DerkyleMsgTHelp.setText("<a:foo>Help</a>");

    }



function DerkyleMsgTHelp::onURL(%this, %url)
{
	MessageBoxOK("HELP",
	"Use the special varibales!  They must be lowercase " @
	"and they must be as follows $name$ for victim name, $count$ for weapon " @
	"count, and $weapon$ for weapon name. Read the README!!!");


}


function DerkMsgTConfig::OnWake(%this){
	DerkUpdateMessages();
	parent::onwake(%this);
}

function DerkUpdateMessages(%this){


	//check for empty messages DUH
	if($pref::DerkMsgTaunt::Message $= ""){
		$pref::DerkMsgTaunt::Message = "Whoops! Suicide $count$.";
	}

	if($pref::DerkMsgTaunt::Message2 $= ""){
		$pref::DerkMsgTaunt::Message2 = "Blasted Lava Gods! Lava Death $count$.";
	}

	if($pref::DerkMsgTaunt::Message3 $= ""){
		$pref::DerkMsgTaunt::Message3 = "Wohoo! $name$ is $weapon$ victim $count$.";
	}

	$pref::DerkMsgTaunt::Message = DerkMsgTMessageBox.getValue();
	$pref::DerkMsgTaunt::Message2 = DerkMsgTMessageBox2.getValue();
	$pref::DerkMsgTaunt::Message3 = DerkMsgTMessageBox3.getValue();
			
	
}




}; // END package DerkMsgTaunt

$DerkTauntIsToggled = true;
$DerkTauntToggleBind = "false";

activatePackage(DerkMsgTaunt);

DerkMsgTauntSetup();